/*
 * jQuery liTarget v 1.0
 *
 * Copyright 2013, Linnik Yura | LI MASS CODE | http://masscode.ru
 * Free to use
 *
 * Last Update 20.02.2014
 */
(function ($) {
	var methods = {
		init: function (options) {
			var p = {
				create: function (el) {},   
				over: function (el) {},   
				out: function (el) {},   
				
			};
			if (options) {
				$.extend(p, options);
			}

			return this.each(function () {
				
				
				if (p.create !== undefined) {
					p.create($(this));
				}
				
				
				var target = $(this);
				var mX;
				var mY;
				var targetL;
				var targetT;
				var wT;
				var wL;
				var catV;
				var catH;
				var gip;
				var deg;
				var degCalc;
				var directArr = $('<div>').addClass('directArr').html('&uarr;').hide().appendTo('body');
				var offsetArr = 30
				var onFlag = true;
				
				target.data({
					'hide':false
				})
				
				var radToDeg = function(rad) { 
					return rad / Math.PI * 180;
				}
				var degToRad = function(deg) { 
					return deg / 180 * Math.PI;
				}
				
				var targetDetect = function(e){
					if(onFlag && !target.data('hide')){
					
						
						mX = e.pageX;
						mY = e.pageY;
						
						directArrW = directArr.width();
						directArrH = directArr.height();
						
						directArrX = mX - directArrW/2;
						directArrY = mY - (directArrH + offsetArr);
						
						wT = $(window).scrollTop();
						wL = $(window).scrollLeft();
						
						directArr.css({left:directArrX - wL, top:directArrY - wT})
						
						
						
						targetL = target.offset().left + target.outerWidth()/2;
						targetT = target.offset().top + target.outerHeight()/2;
								
						catV = mY - targetT;
						catH = mX - targetL;
						
						deg = radToDeg(Math.atan(catH / catV));
						gip = Math.sqrt(catV*catV + catH*catH);
				
						if(mY >= targetT){
							degCalc = 360 - deg;
						}else{
							degCalc = 180 - deg;
						}
						
						directArr.rotate({angle:degCalc, center: ['50%', (directArrH + offsetArr)+'px'] });
						
						if(catV < 0){
							catV = catV * -1	
						}
						if(catH < 0){
							catH = catH * -1	
						}
						
						
						target.data({
							'dist':gip
						})
						
						
						/*
						if(gip < (target.outerHeight()/2 + directArrH + offsetArr) || gip < (target.outerWidth()/2 + directArrW + offsetArr)){
							directArr.stop(true).hide()
						}else{
							directArr.stop(true).show()
						}
						*/
						
						
						if(mY + directArrH + offsetArr > target.offset().top && mY - directArrH - offsetArr < target.offset().top + target.outerHeight() && mX + directArrW + offsetArr > target.offset().left && mX - directArrW - offsetArr < target.offset().left + target.outerWidth()){
							directArr.stop(true).hide()	
						}else{
							directArr.stop(true).show()
						}
						
						
						target.on('mouseenter',function(){
							
							if (p.over !== undefined) {
								p.over($(this));
							}

						}).on('mouseleave',function(){
							
							if (p.out !== undefined) {
								p.out($(this));
							}

						})
					
					}
					
				}
				
				$(document).on('mousemove',function(e){
					targetDetect(e);
				})
				
			});
		},
		enable: function(){
			$(this).data({
				'hide':false
			})
		},
		disable: function(){
			$(this).data({
				'hide':true
			})
		},
		distance: function(){
			return $(this).data('dist')
		}
	};
	$.fn.liTarget = function (method) {
		if (methods[method]) {
			return methods[method].apply(this, Array.prototype.slice.call(arguments, 1));
		} else if (typeof method === 'object' || !method) {
			return methods.init.apply(this, arguments);
		} else {
			$.error('Метод ' + method + ' в jQuery.liTarget не существует');
		}
	};
})(jQuery);